<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 455 $
 * $Id: PermissionFactory.class.php 455 2006-12-21 21:43:09Z ipso $
 * $Date: 2006-12-21 13:43:09 -0800 (Thu, 21 Dec 2006) $
 */
/*
-- Could add an "override" column, that acts like "all" permission. Won't worry about that for now though.
*/
class PermissionFactory extends Factory {
	protected $table = 'permission';
	protected $pk_sequence_name = 'permission_id_seq'; //PK Sequence name

	protected $preset_options = array(
										-1 => '--',
										10 => 'Regular Employee',
										18 => 'Supervisor (Subordinates Only)',
										20 => 'Supervisor (All Employees)',
										30 => 'Payroll Administrator',
										40 => 'Administrator'
									);

	protected $section_group_options = array(
											0 => '<Please Choose>',
											'all' => '-- All --',
											'company' => 'Company',
											'user' => 'Employee',
											'schedule' => 'Schedule',
											'attendance' => 'Attendance',
											'job' => 'Job Tracking',
											'invoice' => 'Invoicing',
											'payroll' => 'Payroll',
											'policy' => 'Policies',
											'report' => 'Reports',
											);
	protected $section_group_map_options = array(
										'company' => array(
															'system',
															'company',
															'branch',
															'department',
															'station',
															'hierarchy',
															'authorization',
															'message',
															'other_field',
															'document',
															'help',
															'permission'
															),
										'user' 	=> array(
															'user',
															'user_preference',
															'user_tax_deduction',
														),
										'schedule' 	=> array(
															'schedule',
															'recurring_schedule',
															'recurring_schedule_template',
														),
										'attendance' 	=> array(
															'request',
															'accrual',
															'punch',
														),
										'job' 	=> array(
															'job',
															'job_item',
															'job_report',
														),
										'invoice' 	=> array(
															'invoice_config',
															'client',
															'client_payment',
															'product',
															'tax_policy',
															'tax_area_policy',
															'transaction',
															'invoice',
															'invoice_report'
														),
										'policy' 	=> array(
															'policy_group',
															'schedule_policy',
															'meal_policy',
															'over_time_policy',
															'premium_policy',
															'accrual_policy',
															'absence_policy',
															'round_policy',
															'exception_policy',
															'holiday_policy',
														),
										'payroll' 	=> array(
															'pay_stub_account',
															'pay_stub',
															'pay_stub_amendment',
															'wage',
															'pay_period_schedule',
															'roe',
															'company_tax_deduction',
														),
										'report' 	=> array(
															'report',
														),

										);
	protected $section_options = array(
										'system' => 'System',
										'company' => 'Company',
										'branch' => 'Branch',
										'department' => 'Department',
										'station' => 'Station',
										'hierarchy' => 'Hierarchy',
										'authorization' => 'Authorization',
										'other_field' => 'Other Fields',
										'document' => 'Documents',
										'message' => 'Message',
										'help' => 'Help',
										'permission' => 'Permissions',

										'user' => 'Employees',
										'user_preference' => 'Employee Preferences',
										'user_tax_deduction' => 'Employee Tax / Deductions',

										'schedule' => 'Schedule',
										'recurring_schedule' => 'Recurring Schedule',
										'recurring_schedule_template' => 'Recurring Schedule Template',

										'request' => 'Requests',
										'accrual' => 'Accruals',
										'punch' => 'Punch',

										'job' => 'Jobs',
										'job_item' => 'Job Tasks',
										'job_report' => 'Job Reports',

										'invoice_config' => 'Invoice Settings',
										'client' => 'Invoice Clients',
										'client_payment' => 'Client Payment Methods',
										'product' => 'Products',
										'tax_policy' => 'Tax Policies',
										'tax_area_policy' => 'Tax Area Policies',
										'transaction' => 'Invoice Transactions',
										'invoice' => 'Invoices',
										'invoice_report' => 'Invoice Reports',

										'policy_group' => 'Policy Group',
										'schedule_policy' => 'Schedule Policies',
										'meal_policy' => 'Meal Policies',
										'over_time_policy' => 'Overtime Policies',
										'premium_policy' => 'Premium Policies',
										'accrual_policy' => 'Accrual Policies',
										'absence_policy' => 'Absence Policies',
										'round_policy' => 'Rounding Policies',
										'exception_policy' => 'Exception Policies',
										'holiday_policy' => 'Holiday Policies',

										'pay_stub_account' => 'Pay Stub Accounts',
										'pay_stub' => 'Employee Pay Stubs',
										'pay_stub_amendment' => 'Employee Pay Stub Amendments',
										'wage' => 'Wages',
										'pay_period_schedule' => 'Pay Period Schedule',
										'roe' => 'Record of Employment',
										'company_tax_deduction' => 'Company Tax / Deductions',

										'report' => 'Reports',
									);

	protected $name_options = array(
											'system' => array(
																'login' => 'Login Enabled',
															),
											'company' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete',
																'edit_own_bank' => 'Edit Own Banking Information'
															),
											'user' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view_child' => 'View Subordinate',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit_child' => 'Edit Subordinate',
																'edit' => 'Edit',
																'edit_advanced' => 'Edit Advanced',
																'edit_own_bank' => 'Edit Own Bank Info',
																'edit_child_bank' => 'Edit Subordinate Bank Info',
																'edit_bank' => 'Edit Banking Information',
																'enroll' => 'Enroll Employees',
																'enroll_child' => 'Enroll Subordinate',
																'delete_own' => 'Delete Own',
																'delete_child' => 'Delete Subordinate',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'user_preference' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view_child' => 'View Subordinate',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit_child' => 'Edit Subordinate',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete_child' => 'Delete Subordinate',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'user_tax_deduction' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view_child' => 'View Subordinate',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit_child' => 'Edit Subordinate',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete_child' => 'Delete Subordinate',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'roe' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view_child' => 'View Subordinate',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit_child' => 'Edit Subordinate',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete_child' => 'Delete Subordinate',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'company_tax_deduction' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'pay_stub_account' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'pay_stub' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view_child' => 'View Subordinate',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit_child' => 'Edit Subordinate',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete_child' => 'Delete Subordinate',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'pay_stub_amendment' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view_child' => 'View Subordinate',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit_child' => 'Edit Subordinate',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete_child' => 'Delete Subordinate',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'wage' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view_child' => 'View Subordinate',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit_child' => 'Edit Subordinate',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete_child' => 'Delete Subordinate',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'branch' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'department' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete',
																'assign' => 'Assign Employees'

															),
											'station' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete',
																'assign' => 'Assign Employees'
															),
											'pay_period_schedule' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete',
																'assign' => 'Assign Employees'
															),
											'schedule' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view_child' => 'View Subordinate',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit_child' => 'Edit Subordinate',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete_child' => 'Delete Subordinate',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete',
															),
											'other_field' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete',
															),
											'document' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'view_private' => 'View Private',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'edit_private' => 'Edit Private',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																'delete_private' => 'Delete Private',
																//'undelete' => 'Un-Delete',
															),
											'accrual' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view_child' => 'View Subordinate',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit_child' => 'Edit Subordinate',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete_child' => 'Delete Subordinate',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'policy_group' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'schedule_policy' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'meal_policy' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'absence_policy' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'accrual_policy' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'over_time_policy' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'premium_policy' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'round_policy' => 	array(
																'enabled' => 'Enabled',
																'view' => 'View',
																'view_own' => 'View Own',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'exception_policy' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'holiday_policy' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),

											'recurring_schedule_template' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'recurring_schedule' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view_child' => 'View Subordinate',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit_child' => 'Edit Subordinate',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete_child' => 'Delete Subordinate',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'request' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view_child' => 'View Subordinate',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit_child' => 'Edit Subordinate',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete_child' => 'Delete Subordinate',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete',
																'authorize' => 'Authorize'
															),
											'punch' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view_child' => 'View Subordinate',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit_child' => 'Edit Subordinate',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete_child' => 'Delete Subordinate',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete',
																'punch_in_out' => 'Punch In/Out',
																'verify_time_sheet' => 'Verify TimeSheet',
															),
											'hierarchy' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'authorization' => 	array(
																'enabled' => 'Enabled',
																'view' => 'View'
															),
											'message' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'add_advanced' => 'Add Advanced',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																'send_to_any' => 'Send to Any Employee',
																'send_to_child' => 'Send to Subordinate'
																//'undelete' => 'Un-Delete'
															),
											'help' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'report' => 		array(
																'enabled' => 'Enabled',
																'view_active_shift' => 'View Active Shifts',
																'view_user_information' => 'View Employee Information',
																'view_user_detail' => 'View Employee Detail',
																'view_pay_stub_summary' => 'Pay Stub Summary',
																'view_wages_payable_summary' => 'Wages Payable Summary',
																//'view_employee_pay_stub_summary' => 'Employee Pay Stub Summary',
																//'view_shift_amendment_summary' => 'Shift Amendment Summary',
																'view_timesheet_summary' => 'Timesheet Summary',
																'view_accrual_balance_summary' => 'Accrual Balance Summary',
																'view_punch_summary' => 'Punch Summary',
																'view_remittance_summary' => 'Remittance Summary',
																//'view_branch_summary' => 'Branch Summary',
																'view_employee_summary' => 'Employee Summary',
																'view_t4_summary' => 'T4 Summary',
																'view_generic_tax_summary' => 'Generic Tax Summary',
																'view_form941' => 'Form 941',
																'view_form940' => 'Form 940',
																'view_form940ez' => 'Form 940-EZ',
																'view_formW2' => 'Form W2 / W3',
																'view_user_barcode' => 'Employee Barcodes',
																'view_general_ledger_summary' => 'General Ledger Summary',
															),
											'job' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'job_item' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'job_report' => 		array(
																'enabled' => 'Enabled',
																'view_job_analysis' => 'View Job Analysis',
																'view_job_summary' => 'View Job Summary',
																'view_job_barcode' => 'View Job Barcode'
															),
											'invoice_config' => 	array(
																'enabled' => 'Enabled',
																'add' => 'Add',
																'edit' => 'Edit',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'client' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'client_payment' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																'view_credit_card' => 'View Credit Card #',																
																//'undelete' => 'Un-Delete'
															),
											'product' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'tax_policy' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'tax_area_policy' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'transaction' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'invoice' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															),
											'invoice_report' => 		array(
																'enabled' => 'Enabled',
																'view_transaction_summary' => 'View Transaction Summary',
															),
											'permission' => 	array(
																'enabled' => 'Enabled',
																'view_own' => 'View Own',
																'view_child' => 'View Subordinate',
																'view' => 'View',
																'add' => 'Add',
																'edit_own' => 'Edit Own',
																'edit_child' => 'Edit Subordinate',
																'edit' => 'Edit',
																'delete_own' => 'Delete Own',
																'delete_child' => 'Delete Subordinate',
																'delete' => 'Delete',
																//'undelete' => 'Un-Delete'
															)
									);

	protected $user_validator_msg = 'Invalid User';
	protected $user_validator_label = 'user';

	protected $company_validator_msg = 'Company is invalid';
	protected $company_validator_label = 'company';

	protected $section_validator_options_msg = 'Incorrect section';
	protected $section_validator_label = 'section';

	protected $name_validator_options_msg = 'Incorrect permission name';
	protected $name_validator_label = 'name';

	protected $value_validator_length_msg = 'Value is invalid';
	protected $value_validator_label = 'value';

	function getUser() {
		if ( isset($this->data['user_id']) ) {
			return $this->data['user_id'];
		}
	}
	function setUser($id) {
		$id = trim($id);

		$ulf = new UserListFactory();

		if ( $id == -1
				OR $this->Validator->isResultSetWithRows(	$this->user_validator_label,
															$ulf->getByID($id),
															$this->user_validator_msg
															) ) {
			$this->data['user_id'] = $id;

			return TRUE;
		}

		return FALSE;
	}

	function getCompany() {
		if ( isset($this->data['company_id']) ) {
			return $this->data['company_id'];
		}

		return FALSE;
	}
	function setCompany($id) {
		$id = trim($id);

		$clf = new CompanyListFactory();

		if ( $id == -1
				OR
				$this->Validator->isResultSetWithRows(	$this->company_validator_label,
													$clf->getByID($id),
													$this->company_validator_msg
													) ) {

			$this->data['company_id'] = $id;

			return TRUE;
		}

		return FALSE;
	}


	function getSection() {
		if ( isset($this->data['section']) ) {
			return $this->data['section'];
		}

		return FALSE;
	}
	function setSection($section) {
		$section = trim($section);

		$key = Option::getByValue($section, $this->getOptions('section') );
		if ($key !== FALSE) {
			$section = $key;
		}

		if ( $this->Validator->inArrayKey(	$this->section_validator_label,
											$section,
											$this->section_validator_options_msg,
											$this->getOptions('section')) ) {

			$this->data['section'] = $section;

			return FALSE;
		}

		return FALSE;
	}

	function getName() {
		if ( isset($this->data['name']) ) {
			return $this->data['name'];
		}

		return FALSE;
	}
	function setName($name) {
		$name = trim($name);

		$key = Option::getByValue($name, $this->getOptions('name', $this->getSection() ) );
		if ($key !== FALSE) {
			$name = $key;
		}

		if ( $this->Validator->inArrayKey(	$this->name_validator_label,
											$name,
											$this->name_validator_options_msg,
											$this->getOptions('name', $this->getSection() ) ) ) {

			$this->data['name'] = $name;

			return FALSE;
		}

		return FALSE;
	}

	function getValue() {
		if ( isset($this->data['value']) AND $this->data['value'] == 1 ) {
			return TRUE;
		} else {
			return FALSE;
		}
		//return $this->data['value'];
	}
	function setValue($value) {
		$value = trim($value);

		Debug::Arr($value, 'Value: ', __FILE__, __LINE__, __METHOD__,10);

		if 	(	$this->Validator->isLength(		$this->value_validator_label,
												$value,
												$this->value_validator_length_msg,
												1,
												255) ) {

			$this->data['value'] = $value;

			return TRUE;
		}

		return FALSE;
	}

	function applyPreset($user_ids, $preset, $preset_flags) {
		//Each preset is built off one another.
		$key = Option::getByValue($preset, $this->getOptions('preset') );
		if ($key !== FALSE) {
			$preset = $key;
		}

		if ( isProfessionalEditionAvailable() == FALSE ) {
			$preset_flags = array();
		}
/*
										10 => 'Regular Employee',
										20 => 'Supervisor',
										30 => 'Payroll Administrator',
										40 => 'Administrator'
*/
		Debug::Text('Preset: '. $preset, __FILE__, __LINE__, __METHOD__,10);
		Debug::Arr($preset_flags, 'Preset Flags... ', __FILE__, __LINE__, __METHOD__,10);

		if ( !isset($preset) OR $preset == '' OR $preset == -1 ) {
			Debug::Text('No Preset set... Skipping!', __FILE__, __LINE__, __METHOD__,10);
			return FALSE;
		}

		$preset_permissions_40 = array();
		$preset_permissions_30 = array();
		$preset_permissions_20 = array();
		$preset_permissions_18 = array();
		$preset_permissions_10 = array();
		switch( $preset ) {
			case 40:
				//Can do everything
				$preset_permissions_40 = array(
											'policy_group' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'schedule_policy' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'meal_policy' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'over_time_policy' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'premium_policy' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'accrual_policy' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'absence_policy' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'round_policy' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'exception_policy' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'holiday_policy' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'branch' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'department' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
																'assign' => TRUE

															),
											'station' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
																'assign' => TRUE
															),
											'report' => 		array(
																//'view_shift_actual_time' => TRUE,
															),
											'hierarchy' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'round_policy' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'other_field' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'permission' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															)
											);
				if ( isset($preset_flags['invoice']) AND $preset_flags['invoice'] == 1 ) {
					Debug::Text('Applying Invoice Permissions for Admin Preset', __FILE__, __LINE__, __METHOD__,10);
					$invoice_preset_permissions_40 = array(
											'invoice_config' => 	array(
																'enabled' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
													);
					$preset_permissions_40 = array_merge( $preset_permissions_40, $invoice_preset_permissions_40);
					unset($invoice_preset_permissions_40);
				} else {
					Debug::Text('NOT Applying Invoice Permissions for Admin Preset', __FILE__, __LINE__, __METHOD__,10);
				}
			case 30:
				//Payroll Admin, can do wages, taxes, etc...
				$preset_permissions_30 = array(
											'company' => 	array(
																'enabled' => TRUE,
																'view_own' => TRUE,
																'edit_own' => TRUE,
																'edit_own_bank' => TRUE
															),
											'user' => 	array(
																'add' => TRUE,
																'edit_bank' => TRUE,
															),
											'user_tax_deduction' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'roe' => 		array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'company_tax_deduction' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'pay_stub_account' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE
															),
											'pay_stub' => 	array(
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE
															),
											'pay_stub_amendment' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE
															),
											'wage' => 		array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE
															),
											'pay_period_schedule' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
																'assign' => TRUE
															),
											'report' => 		array(
																'view_pay_stub_summary' => TRUE,
																//'view_employee_pay_stub_summary' => TRUE,
																'view_remittance_summary' => TRUE,
																//'view_branch_summary' => TRUE,
																'view_employee_summary' => TRUE,
																'view_wages_payable_summary' => TRUE,
																'view_t4_summary' => TRUE,
																'view_generic_tax_summary' => TRUE,
																'view_form941' => TRUE,
																'view_form940' => TRUE,
																'view_form940ez' => TRUE,
																'view_formW2' => TRUE,
																'view_general_ledger_summary' => TRUE
															),
											);
				if ( isset($preset_flags['invoice']) AND $preset_flags['invoice'] == 1 ) {
					Debug::Text('Applying Invoice Permissions for Payroll Admin Preset', __FILE__, __LINE__, __METHOD__,10);
					$invoice_preset_permissions_30 = array(
											'product' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'tax_policy' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'tax_area_policy' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'invoice_report' => 	array(
																'enabled' => TRUE,
																'view_transaction_summary' => TRUE,
															),
													);
					$preset_permissions_30 = array_merge( $preset_permissions_30, $invoice_preset_permissions_30);
					unset($invoice_preset_permissions_30);
				} else {
					Debug::Text('NOT Applying Invoice Permissions for Payroll Admin Preset', __FILE__, __LINE__, __METHOD__,10);
				}
			case 20:
				//Supervisor, can see all schedules and shifts, and can do authorizations
				$preset_permissions_20 = array(
											'user' => 	array(
																'view' => TRUE,
																'edit' => TRUE,
																'enroll' => TRUE,
																'delete' => TRUE
															),
											'user_preference' => 	array(
																'edit' => TRUE,
															),
											'recurring_schedule_template' => 	array(
																'view' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'recurring_schedule' => 	array(
																'view' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'punch' => 	array(
																'view' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),

											'accrual' => 	array(
																'view' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'request' => 	array(
																'view' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'schedule' => 	array(
																'view' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE
															),
											'message' => 	array(
																'send_to_any' => TRUE,
															),
											/*					
											'report' => 		array(
																'enabled' => TRUE,
																'view_active_shift' => TRUE,
																'view_user_information' => TRUE,
																'view_user_detail' => TRUE,
																'view_timesheet_summary' => TRUE,
																'view_punch_summary' => TRUE,
																'view_accrual_balance_summary' => TRUE,
																'view_user_barcode' => TRUE,
															)
											*/																	
											);

				//
				// Most of this is done on level 18;
				//
				
				if ( isset($preset_flags['job']) AND $preset_flags['job'] == 1 ) {
					Debug::Text('Applying Job Permissions for Supervisor Preset', __FILE__, __LINE__, __METHOD__,10);
					$job_preset_permissions_20 = array(
											'job' => 	array(
																'view' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
													);
					$preset_permissions_20 = array_merge( $preset_permissions_20, $job_preset_permissions_20);
					unset($job_preset_permissions_20);
				} else {
					Debug::Text('NOT Applying Job Permissions for Supervisor Preset', __FILE__, __LINE__, __METHOD__,10);
				}
/*
				if ( isset($preset_flags['invoice']) AND $preset_flags['invoice'] == 1 ) {
					Debug::Text('Applying Invoice Permissions for Supervisor Preset', __FILE__, __LINE__, __METHOD__,10);
					$invoice_preset_permissions_20 = array(
											'client' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'client_payment' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'transaction' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'invoice' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
													);
					$preset_permissions_20 = array_merge( $preset_permissions_20, $invoice_preset_permissions_20);
					unset($invoice_preset_permissions_20);
				} else {
					Debug::Text('NOT Applying Invoice Permissions for Supervisor Preset', __FILE__, __LINE__, __METHOD__,10);
				}				

				if ( isset($preset_flags['document']) AND $preset_flags['document'] == 1 ) {
					Debug::Text('Applying Document Permissions for Supervisor Preset', __FILE__, __LINE__, __METHOD__,10);
					$document_preset_permissions_20 = array(
											'document' => 	array(
																'add' => TRUE,
																'view_private' => TRUE,
																'edit' => TRUE,
																'edit_private' => TRUE,
																'delete' => TRUE,
																'delete_private' => TRUE,
															),
													);
					$preset_permissions_20 = array_merge( $preset_permissions_20, $document_preset_permissions_20);
					unset($document_preset_permissions_20);
				} else {
					Debug::Text('NOT Applying Document Permissions for Supervisor Preset', __FILE__, __LINE__, __METHOD__,10);
				}
*/			
			case 18:
				//Supervisor, can see all schedules and shifts, and can do authorizations
				$preset_permissions_18 = array(
											'user' => 	array(
																'view_child' => TRUE,
																'edit_child' => TRUE,
																'edit_advanced' => TRUE,
																'enroll_child' => TRUE,
																'delete_child' => TRUE
															),
											'user_preference' => 	array(
																'edit_child' => TRUE,
															),
											'recurring_schedule_template' => 	array(
																'enabled' => TRUE,
																'view_own' => TRUE,
																'add' => TRUE,
																'edit_own' => TRUE,
																'delete_own' => TRUE,
															),
											'recurring_schedule' => 	array(
																'enabled' => TRUE,
																'view_child' => TRUE,
																'add' => TRUE,
																'edit_child' => TRUE,
																'delete_child' => TRUE,
															),
											'punch' => 	array(
																'view_child' => TRUE,
																'edit_child' => TRUE,
																'delete_child' => TRUE,
															),

											'accrual' => 	array(
																'view_child' => TRUE,
																'add' => TRUE,
																'edit_child' => TRUE,
																'delete_child' => TRUE,
															),
											'request' => 	array(
																'view_child' => TRUE,
																'edit_child' => TRUE,
																'delete_child' => TRUE,
																'authorize' => TRUE
															),
											'schedule' => 	array(
																'add' => TRUE,
																'view_child' => TRUE,
																'edit_child' => TRUE,
																'delete_child' => TRUE
															),
											'authorization' => 	array(
																'enabled' => TRUE,
																'view' => TRUE
															),
											'message' => 	array(
																'add_advanced' => TRUE,
																'send_to_child' => TRUE,
															),
											'report' => 		array(
																'enabled' => TRUE,
																'view_active_shift' => TRUE,
																'view_user_information' => TRUE,
																'view_user_detail' => TRUE,
																'view_timesheet_summary' => TRUE,
																'view_punch_summary' => TRUE,
																'view_accrual_balance_summary' => TRUE,
																'view_user_barcode' => TRUE,
															)
											);

				if ( isset($preset_flags['job']) AND $preset_flags['job'] == 1 ) {
					Debug::Text('Applying Job Permissions for Supervisor Preset', __FILE__, __LINE__, __METHOD__,10);
					$job_preset_permissions_18 = array(
											'job' => 	array(
																'view_own' => TRUE,
																'add' => TRUE,
																'edit_own' => TRUE,
																'delete_own' => TRUE,
															),
											'job_item' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit_own' => TRUE,
																'delete_own' => TRUE,
															),
											'job_report' => array(
																'enabled' => TRUE,
																'view_job_analysis' => TRUE,
																'view_job_summary' => TRUE,
																'view_job_barcode' => TRUE
															),
													);
					$preset_permissions_18 = array_merge( $preset_permissions_18, $job_preset_permissions_18);
					unset($job_preset_permissions_18);
				} else {
					Debug::Text('NOT Applying Job Permissions for Supervisor Preset', __FILE__, __LINE__, __METHOD__,10);
				}

				if ( isset($preset_flags['invoice']) AND $preset_flags['invoice'] == 1 ) {
					Debug::Text('Applying Invoice Permissions for Supervisor Preset', __FILE__, __LINE__, __METHOD__,10);
					$invoice_preset_permissions_18 = array(
											'client' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'client_payment' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'transaction' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
											'invoice' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
																'add' => TRUE,
																'edit' => TRUE,
																'delete' => TRUE,
															),
													);
					$preset_permissions_18 = array_merge( $preset_permissions_18, $invoice_preset_permissions_18);
					unset($invoice_preset_permissions_18);
				} else {
					Debug::Text('NOT Applying Invoice Permissions for Supervisor Preset', __FILE__, __LINE__, __METHOD__,10);
				}

				if ( isset($preset_flags['document']) AND $preset_flags['document'] == 1 ) {
					Debug::Text('Applying Document Permissions for Supervisor Preset', __FILE__, __LINE__, __METHOD__,10);
					$document_preset_permissions_18 = array(
											'document' => 	array(
																'add' => TRUE,
																'view_private' => TRUE,
																'edit' => TRUE,
																'edit_private' => TRUE,
																'delete' => TRUE,
																'delete_private' => TRUE,
															),
													);
					$preset_permissions_18 = array_merge( $preset_permissions_18, $document_preset_permissions_18);
					unset($document_preset_permissions_18);
				} else {
					Debug::Text('NOT Applying Document Permissions for Supervisor Preset', __FILE__, __LINE__, __METHOD__,10);
				}
			case 10:
				$preset_permissions_10 = array(
											'system' => array(
																'login' => TRUE,
															),
											'user' => 	array(
																'enabled' => TRUE,
																'view_own' => TRUE,
																'edit_own' => TRUE,
																'edit_own_bank' => TRUE,
															),
											'user_preference' => 	array(
																'enabled' => TRUE,
																'view_own' => TRUE,
																'add' => TRUE,
																'edit_own' => TRUE,
																'delete_own' => TRUE,
															),
											'pay_stub' => 	array(
																'enabled' => TRUE,
																'view_own' => TRUE,
															),
											'accrual' => 	array(
																'enabled' => TRUE,
																'view_own' => TRUE
															),
											'request' => 	array(
																'enabled' => TRUE,
																'view_own' => TRUE,
																'add' => TRUE,
																'edit_own' => TRUE,
																'delete_own' => TRUE,
															),
											'schedule' => 	array(
																'enabled' => TRUE,
																'view_own' => TRUE,
															),
											'punch' => 	array(
																'enabled' => TRUE,
																'view_own' => TRUE,
																'add' => TRUE,
																'punch_in_out' => TRUE,
																'verify_time_sheet' => TRUE,
															),
											'message' => 	array(
																'enabled' => TRUE,
																'view_own' => TRUE,
																'add' => TRUE,
																'edit_own' => TRUE,
																'delete_own' => TRUE,
															),
											'help' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
															)
										);

				if ( isset($preset_flags['job']) AND $preset_flags['job'] == 1 ) {
					Debug::Text('Applying Job Permissions for Regular Preset', __FILE__, __LINE__, __METHOD__,10);
					$job_preset_permissions_10 = array(
											'job' => 	array(
																'enabled' => TRUE,
															),
													);
					$preset_permissions_10 = array_merge( $preset_permissions_10, $job_preset_permissions_10);
					unset($job_preset_permissions_10);
				} else {
					Debug::Text('NOT Applying Job Permissions for Regular Preset', __FILE__, __LINE__, __METHOD__,10);
				}

				if ( isset($preset_flags['document']) AND $preset_flags['document'] == 1 ) {
					Debug::Text('Applying Document Permissions for Regular Preset', __FILE__, __LINE__, __METHOD__,10);
					$document_preset_permissions_10 = array(
											'document' => 	array(
																'enabled' => TRUE,
																'view' => TRUE,
															),
													);
					$preset_permissions_10 = array_merge( $preset_permissions_10, $document_preset_permissions_10);
					unset($document_preset_permissions_10);
				} else {
					Debug::Text('NOT Applying Document Permissions for Regular Preset', __FILE__, __LINE__, __METHOD__,10);
				}
		}

		//Merge all permissions
		$preset_permissions = array_merge_recursive($preset_permissions_10, $preset_permissions_18, $preset_permissions_20, $preset_permissions_30, $preset_permissions_40);
		//var_dump($preset_permissions);

		$pf = new PermissionFactory();
		$pf->StartTransaction();

		foreach($user_ids as $user_id) {
			if ( $user_id == -1 ) {
				global $current_company;
				$company_id = $current_company->getId();
			} else {
				$ulf = new UserListFactory();
				$company_id = $ulf->getById ( $user_id )->getCurrent()->getCompany();
			}

			//Delete all previous permissions for this user.
			$this->deletePermissions($company_id, $user_id);

			foreach($preset_permissions as $section => $permissions) {
				foreach($permissions as $name => $value) {
					Debug::Text('Setting Permission - Section: '. $section .' Name: '. $name .' Value: '. (int)$value, __FILE__, __LINE__, __METHOD__,10);

					$pf->setCompany( $company_id );
					$pf->setUser( $user_id );
					$pf->setSection( $section );
					$pf->setName( $name );
					$pf->setValue( (int)$value );

					if ( $pf->isValid() ) {
						$pf->save();
					}

				}
			}

			$pf->clearCache( $user_id, $company_id );
		}

		//$pf->FailTransaction();
		$pf->CommitTransaction();

		return TRUE;
	}

	function deletePermissions( $company_id, $user_id ){
		if ( $company_id == '' ) {
			return FALSE;
		}

		if ( $user_id == '' ) {
			return FALSE;
		}

		$plf = new PermissionListFactory();
		$plf->getByCompanyIDAndUserId( $company_id, $user_id );
		foreach($plf as $permission_obj) {
			$permission_obj->delete(TRUE);
			$this->removeCache( $this->getCacheID() );
		}

		return TRUE;
	}

	static function isIgnore( $section, $name = NULL, $product_edition = 10 ) {
		//Ignore by default
		if ( $section == '' ) {
			return TRUE;
		}

		Debug::Text(' Product Edition: '. $product_edition, __FILE__, __LINE__, __METHOD__,10);
		if ( $product_edition == 20 ) {
			$ignore_permissions = array('help' => 'ALL',
										'company' => array('add','delete','delete_own','undelete','view','edit'),
										);
		} else {
			$ignore_permissions = array('help' => 'ALL',
										'company' => array('add','delete','delete_own','undelete','view','edit'),
										//'pay_stub' => array('edit','edit_own'),
										'job_report' => 'ALL',
										'invoice_report' => 'ALL',
										'invoice' => 'ALL',
										'job' => 'ALL',
										'document' => 'ALL',
										);
		}

		if ( isset($ignore_permissions[$section])
				AND
					(
						(
							$name != ''
							AND
							($ignore_permissions[$section] == 'ALL'
							OR ( is_array($ignore_permissions[$section]) AND in_array($name, $ignore_permissions[$section]) ) )
						)
						OR
						(
							$name == ''
							AND
							$ignore_permissions[$section] == 'ALL'
						)
					)

					) {
			Debug::Text(' IGNORING... Section: '. $section .' Name: '. $name, __FILE__, __LINE__, __METHOD__,10);
			return TRUE;
		} else {
			Debug::Text(' NOT IGNORING... Section: '. $section .' Name: '. $name, __FILE__, __LINE__, __METHOD__,10);
			return FALSE;
		}
	}

	function preSave() {
		//Delete already existing permission first?
		$plf = new PermissionListFactory();
		$obj = $plf->getByCompanyIdAndUserIdAndSectionAndName( $this->getCompany(), $this->getUser(), $this->getSection(), $this->getName() )->getCurrent();
		$this->setId( $obj->getId() );

		return TRUE;
	}

	function getCacheID() {
		$cache_id = 'permission::query_'.$this->getSection().$this->getName().$this->getUser().$this->getCompany();

		return $cache_id;
	}

	function clearCache( $user_id, $company_id ) {
		$cache_id = 'permission::all'.$user_id.$company_id;
		return $this->removeCache( $cache_id );
	}

	function postSave() {
		//$cache_id = 'permission::query_'.$this->getSection().$this->getName().$this->getUser().$this->getCompany();
		//$this->removeCache( $this->getCacheID() );

		return TRUE;
	}
}
?>
