<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 452 $
 * $Id: cron.php 452 2006-12-20 00:24:49Z ipso $
 * $Date: 2006-12-19 16:24:49 -0800 (Tue, 19 Dec 2006) $
 */
/*
 * Cron replica
 * Run this script every minute from the real cron.
 *
 */
require_once( dirname(__FILE__) . DIRECTORY_SEPARATOR .'..'. DIRECTORY_SEPARATOR .'includes'. DIRECTORY_SEPARATOR .'global.inc.php');
require_once( dirname(__FILE__) . DIRECTORY_SEPARATOR .'..'. DIRECTORY_SEPARATOR .'includes'. DIRECTORY_SEPARATOR .'CLI.inc.php');

$cjlf = new CronJobListFactory();
$cjlf->getAll();
$executed_jobs=0;
$total_jobs = $cjlf->getRecordCount();
foreach( $cjlf as $cjf_obj ) {
	if ( $cjf_obj->isScheduledToRun() == TRUE ) {
		$executed_jobs++;
		$cjf_obj->Execute();
	}
}
echo "Jobs Executed: $executed_jobs of $total_jobs\n";

//Save file to log directory with the last executed date, so we know if the CRON daemon is actually calling us.
$file_name = $config_vars['path']['log'] . DIRECTORY_SEPARATOR .'timetrex_cron_last_executed.log';
file_put_contents( $file_name, TTDate::getDate('DATE+TIME', time() )."\n" );

Debug::Display();
?>